/*************************************************************************
Checksum Tool
**************************************************************************/
#include "cstool.h"

HWND_WNDPROC_INFO DlgInfo;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
   INITCOMMONCONTROLSEX blah;
   blah.dwSize = sizeof(INITCOMMONCONTROLSEX);
   blah.dwICC = -1;
   InitCommonControlsEx(&blah);
   memset(&DlgInfo, 0, sizeof(HWND_WNDPROC_INFO));
   DlgInfo.hInstance = hInstance;
   DlgInfo.Main = CreateDialog(hInstance,MAKEINTRESOURCE(CSTOOL_DLG),HWND_DESKTOP,MainProc);
   char ErrTxt[1024];
   sprintf(ErrTxt, "%u", GetLastError());
   if (!DlgInfo.Main) { MessageBox(NULL,ErrTxt, "debug",MB_OK); return FALSE; }

   ShowWindow(DlgInfo.Main, nCmdShow);
   UpdateWindow(DlgInfo.Main);
   MSG msg;
//   HACCEL AccelMain = LoadAccelerators(hinstMain, "MainAccel");
   while(GetMessage(&msg, NULL, 0, 0))
   {
//       if (!TranslateAccelerator(hwndMain, AccelMain, &msg)) {
           TranslateMessage(&msg);
           DispatchMessage(&msg);
//       }
    }
   return (int)msg.wParam;
}

BOOL CALLBACK MainProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	switch(Message)
	{
		case WM_COMMAND:
		{
			switch(LOWORD(wParam))
            {
				case PICK_SAVE_CMD:
				{
					char SaveFileName[MAX_PATH];
					if (!DoFileOpen(hwnd, SaveFileName)) { break; }
					//do checksum
					s64 newCS = Juiced_Checksum(SaveFileName);
					MessageBox(DlgInfo.Main, "Operation Complete", "Oh Hell Yeah", MB_OK);
//					ShowError("bah %I64X", newCS);
				} break;
			} break;
		} break;
		case WM_CLOSE:
		{
            DestroyWindow(hwnd);
		} break;
		case WM_DESTROY:
		{
			PostQuitMessage(0);
        } return 0;
		default:
			return FALSE;
	}
	return FALSE;
}

/****************************************************************************
Show Error - Error Callback
*****************************************************************************/
int ShowError(const char* FmtString, ...)
{
    va_list arglist;
    va_start(arglist, FmtString);
    char tmpText[4096];
    vsprintf(tmpText, FmtString, arglist);
    va_end(arglist);
    MessageBox(DlgInfo.Main, tmpText, "Jupitor's Cock!", MB_OK);
    return 0;
}

/****************************************************************************
Calculate and store checksum
*****************************************************************************/
s64 Juiced_Checksum(char *filename)
{
	u32 filesize = 0;
	if ((filesize = FileExists(filename)) == 0) { ShowError( "File (%s) doesn't seem to exist.", filename); }
//	u32 chkStart = 0x3296C;
	u32 chkLen = 0x9A640;
	u8 *SaveData;
	if (!(LoadFile(&SaveData, filename, 0, NULL, FALSE, -1))) { return 0; }
	if ( 0x269906 != filesize) {
		ShowError("This doesn't appear to be a save data file."); return 0;
	}

	u64 chkVal1, chkVal2;
	u64 chkSum = 0LL;
	u32 DataLoc = 0;

	do
	{
		chkLen--;

		chkVal1 = (SaveData[DataLoc] << 24) | (SaveData[DataLoc+1] << 16) | (SaveData[DataLoc+2] << 8) | SaveData[DataLoc+3];

		DataLoc += 4;
		chkSum += chkVal1;
	} while (chkLen > 0);

	int i;
	for (i = 0; i < 4; i++) {
	SaveData[0x269902 + i] = ByteFromU64((u64)chkSum, i+4);
//	ShowError("%08X", SaveData[0x269902 + i]);
	}
//	ShowError("is it %08X, %010I64X", DataLoc, chkSum);
	if (!(SaveFile(SaveData, filesize, filename, 0, NULL))) { return 0; }

	return chkSum;
}
