/**************************************************************************
Checksum Tool
**************************************************************************/
#include <w32api.h>
#define WINVER WindowsNT4
#define _WIN32_IE IE6

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <shlobj.h>
#include <ctype.h>
//#include <psapi.h>
#include "_types.h"
#include "cstool_gui.h"
#include "lib_fileio.h"
#include "lib_misc.h"

/****************************************************************************
Global Constants
*****************************************************************************/
#define NUM_TABS 7
#define MAX_SEARCHES 100
#define MAX_SUBCLASSES 100


//dialog globals
typedef struct _HWND_WNDPROC_INFO {
	HINSTANCE hInstance;
	HWND Main;
	HMENU Menu;
    HFONT ValueHFont;
	HWND TabDlgs[NUM_TABS];
	WNDPROC SubclassProcs[MAX_SUBCLASSES];
	int SubclassIds[MAX_SUBCLASSES];
//	LISTVIEW_ITEM_EDIT_INFO lvEdit[NUM_LSV_EDIT];
} HWND_WNDPROC_INFO;


/****************************************************************************
Function Declarations -should also be a guidline to help people find where
most any function is located except some library stuff.
*****************************************************************************/

//cstool
BOOL CALLBACK MainProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
int ShowError(const char* FmtString, ...);
s64 Juiced_Checksum(char *filename);

//lib_api
LRESULT CALLBACK HexEditBoxHandler (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int ComboAddItem(HWND hCombo, const char* combostring, DWORD value);
int ComboSelFromData (HWND hCombo, u32 DataValue);
int isHexWindow(HWND txtbox);
u64 GetHexWindow(HWND txtbox);
int SetHexWindow(HWND txtbox, u64 value);
u64 isDecWindow(HWND txtbox);
u64 GetDecWindow(HWND txtbox);
int SetDecWindowU(HWND txtbox, u64 value);
int SetDecWindowS(HWND txtbox, u64 value);
u64 IsFloatWindow(HWND txtbox);
u64 GetFloatWindow(HWND txtbox, int fsize);
int SetFloatWindow(HWND txtbox, u64 value, int fsize);
int DoFileOpen(HWND hwnd, char* filename);
int BrowseForFolder(HWND hwnd, char* filename);
int DoSelectFont(HWND hwnd, LOGFONT *lf, COLORREF *clr);
int SetMenuState(HMENU hMenu, UINT id, UINT state);
int SetMenuItemText(HMENU hMenu, UINT id, const char* MenuText);
int SetMenuItemData(HMENU hMenu, UINT id, UINT data);
int GetMenuItemData(HMENU hMenu, UINT id);
BOOL EnableTokenPrivilege (LPTSTR privilege);
int GetAppPath(char *CFGFile);
